/* File bsb_writef.c */

#include <stdio.h>	/* fopen fwrite fclose fwrite printf */
#include <string.h>	/* strncpy */

/* Number_of_characters is related to Dimensionality of vectors */
#define Number_of_characters (int)(25)
#define Dimensionality       (int)(8*Number_of_characters)
/* Maximum_set_size is the size of each training set */
#define Maximum_set_size     (int)(100)
/* String_length refers to strings in the struct Stimulus.Name */
#define String_length   (int)(60)       /* Must be > Number_of_characters */

typedef float Vector[Dimensionality];
typedef char String[String_length+1];
typedef struct {
    String Name;
    Vector Val;
} Stimulus;

/* Defined in bsb.c */
/* Element [0] does not appear to be used anywhere */
Stimulus F_set[Maximum_set_size+1];
Stimulus G_set[Maximum_set_size+1];
Stimulus T_set[Maximum_set_size+1];
extern char FFileName[];
extern char GFileName[];
extern char TFileName[];

/* Defined in bsb_num.c */
int Number_present_in_set(char Which_set);

/* Defined in bsb_vt100.c */
void Bottom_line(void);

/* Defined in bsb_writef.c */
void Write_file(char Which_file);

/*----------------------------------------------------------------------
When stimulus files are created or modified, the results can be
written to disk.
----------------------------------------------------------------------*/
void Write_file(char Which_file) {
    int i;	/* loop index */
    int Number_in_set;	/* number of lines in stimulus set */
    char File_name[80+1];	/* file name of stimulus file */
    FILE *Working_file;

    Bottom_line();
    if(Which_file=='F' || Which_file=='f') {
        strncpy(File_name,FFileName,80); File_name[80]='\0';
        Number_in_set=Number_present_in_set('F'); 
    } else if(Which_file=='G' || Which_file=='g') {
        strncpy(File_name,GFileName,80); File_name[80]='\0';
        Number_in_set=Number_present_in_set('G'); 
    } else if(Which_file=='T' || Which_file=='t') {
        strncpy(File_name,TFileName,80); File_name[80]='\0';
        Number_in_set=Number_present_in_set('T'); 
    }

    Bottom_line();
    Working_file=fopen(File_name,"w");
    if(Working_file==NULL) {
        printf("Failed to open %c file \'%s\'\n",Which_file,File_name);
    } else {
        printf("Writing %2d stimuli to %c file.",Number_in_set,Which_file);
        if(Which_file=='F' || Which_file=='f') {
            for(i=1; i<=Number_in_set; i++)
               fwrite(&F_set[i],sizeof(Stimulus),1,Working_file); 
        } else if(Which_file=='G' || Which_file=='g') {
            for(i=1; i<=Number_in_set; i++) 
               fwrite(&G_set[i],sizeof(Stimulus),1,Working_file); 
        } else if(Which_file=='T' || Which_file=='t') {
            for(i=1; i<=Number_in_set; i++) 
               fwrite(&T_set[i],sizeof(Stimulus),1,Working_file); 
        }
        fclose(Working_file);
    }
}   /* Which_file */

